
#ifndef MODULES_HESAI_LIDAR_H_
#define MODULES_HESAI_LIDAR_H_


#include <publisher.h>

#include "system_utils.h"
#include <cstring>

#include <queue>
#include <stdbool.h>
#include "hesailidar_sdk/driver/hesai_lidar_sdk.hpp"
#include "server_activity.h"
#include "lidar_hesai_right/executable.h"


class HesaiLidar : public ServerActivity {
public:
    std::string frame_name = "iv_points";
    std::string topic = "lidar_roof_node";
    
    HesaiLidar();
    ~HesaiLidar() = default;
    int SetPoints(const hesai::lidar::LidarDecodedFrame<hesai::lidar::LidarPointXYZIRT>  &frame);
    void sendPointCloud();

    void testLog(){
        printf("This is test log\n\n");
    };
    void setReady();
    bool isReady();
    void Publish(mdc::visual::PointCloud<mdc::visual::PointXYZIR> pc);
    void RunThread();
    bool OnInit();
    void OnSend();
    void Init();


protected:

private:
    // std::size_t points_size = 4*1024*1024;
    bool ready = 0;
    // CircularVector points;
    int width = 0;
    mdc::visual::Publisher pointCloud2Pub {};
    mdc::visual::Publisher pcPointXYZIRPub {};
    mdc::visual::PointCloud<mdc::visual::PointXYZIR> pcXYZIRGlobal {};
    std::queue<mdc::visual::PointCloud<mdc::visual::PointXYZIR>> pointsQueue;
    std::shared_ptr<jac::ap::hesairightlidarservice::skeleton::HesaiRightLiDARServiceSkeleton> skeleton_;


};

#endif /* MODULES_HESAI_LIDAR_H_ */
